// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.Management.Compute.Models;

namespace Microsoft.WindowsAzure.Management.Compute.Models
{
    /// <summary>
    /// The List Hosted Service operation response.
    /// </summary>
    public partial class HostedServiceListResponse : OperationResponse, IEnumerable<HostedServiceListResponse.HostedService>
    {
        private IList<HostedServiceListResponse.HostedService> _hostedServices;
        
        /// <summary>
        /// Optional. The hosted services associated with your subscription.
        /// </summary>
        public IList<HostedServiceListResponse.HostedService> HostedServices
        {
            get { return this._hostedServices; }
            set { this._hostedServices = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the HostedServiceListResponse class.
        /// </summary>
        public HostedServiceListResponse()
        {
            this._hostedServices = new List<HostedServiceListResponse.HostedService>();
        }
        
        /// <summary>
        /// Gets the sequence of HostedServices.
        /// </summary>
        public IEnumerator<HostedServiceListResponse.HostedService> GetEnumerator()
        {
            return this.HostedServices.GetEnumerator();
        }
        
        /// <summary>
        /// Gets the sequence of HostedServices.
        /// </summary>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }
        
        /// <summary>
        /// A hosted service associated with your subscription.
        /// </summary>
        public partial class HostedService
        {
            private HostedServiceProperties _properties;
            
            /// <summary>
            /// Optional. The properties that are assigned to the cloud service.
            /// </summary>
            public HostedServiceProperties Properties
            {
                get { return this._properties; }
                set { this._properties = value; }
            }
            
            private string _serviceName;
            
            /// <summary>
            /// Optional. The name of the cloud service. This name is the DNS
            /// prefix name and can be used to access the cloud service. For
            /// example, if the cloud service name is MyService you could
            /// access the cloud service by calling:
            /// http://MyService.cloudapp.net.
            /// </summary>
            public string ServiceName
            {
                get { return this._serviceName; }
                set { this._serviceName = value; }
            }
            
            private Uri _uri;
            
            /// <summary>
            /// Optional. The Service Management API request URI used to
            /// perform List Hosted Service Properties requests against the
            /// cloud service.
            /// </summary>
            public Uri Uri
            {
                get { return this._uri; }
                set { this._uri = value; }
            }
            
            /// <summary>
            /// Initializes a new instance of the HostedService class.
            /// </summary>
            public HostedService()
            {
            }
        }
    }
}
