// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Gallery;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.Common;

namespace Microsoft.Azure.Gallery
{
    public partial class GalleryClient : ServiceClient<GalleryClient>, IGalleryClient
    {
        private Uri _baseUri;
        
        /// <summary>
        /// The URI used as the base for all cloud service management requests.
        /// </summary>
        public Uri BaseUri
        {
            get { return this._baseUri; }
        }
        
        private SubscriptionCloudCredentials _credentials;
        
        /// <summary>
        /// Gets or sets subscription credentials which uniquely identify
        /// Windows  Azure subscription. The subscription ID forms part of the
        /// URI for  every call that you make to the Service Management API.
        /// </summary>
        public SubscriptionCloudCredentials Credentials
        {
            get { return this._credentials; }
        }
        
        private IItemOperations _items;
        
        /// <summary>
        /// Operations for working with gallery items.
        /// </summary>
        public virtual IItemOperations Items
        {
            get { return this._items; }
        }
        
        /// <summary>
        /// Initializes a new instance of the GalleryClient class.
        /// </summary>
        private GalleryClient()
            : base()
        {
            this._items = new ItemOperations(this);
            this.HttpClient.Timeout = TimeSpan.FromSeconds(300);
        }
        
        /// <summary>
        /// Initializes a new instance of the GalleryClient class.
        /// </summary>
        /// <param name='credentials'>
        /// Required. Gets or sets subscription credentials which uniquely
        /// identify Windows  Azure subscription. The subscription ID forms
        /// part of the URI for  every call that you make to the Service
        /// Management API.
        /// </param>
        /// <param name='baseUri'>
        /// Required. The URI used as the base for all cloud service management
        /// requests.
        /// </param>
        public GalleryClient(SubscriptionCloudCredentials credentials, Uri baseUri)
            : this()
        {
            if (credentials == null)
            {
                throw new ArgumentNullException("credentials");
            }
            if (baseUri == null)
            {
                throw new ArgumentNullException("baseUri");
            }
            this._credentials = credentials;
            this._baseUri = baseUri;
            
            this.Credentials.InitializeServiceClient(this);
        }
        
        /// <summary>
        /// Initializes a new instance of the GalleryClient class.
        /// </summary>
        /// <param name='credentials'>
        /// Required. Gets or sets subscription credentials which uniquely
        /// identify Windows  Azure subscription. The subscription ID forms
        /// part of the URI for  every call that you make to the Service
        /// Management API.
        /// </param>
        public GalleryClient(SubscriptionCloudCredentials credentials)
            : this()
        {
            if (credentials == null)
            {
                throw new ArgumentNullException("credentials");
            }
            this._credentials = credentials;
            this._baseUri = new Uri("https://gallery.azure.com/");
            
            this.Credentials.InitializeServiceClient(this);
        }
    }
}
