// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.Models
{
    /// <summary>
    /// Parameters supplied to the Create Affinity Group operation.
    /// </summary>
    public partial class AffinityGroupCreateParameters
    {
        private string _description;
        
        /// <summary>
        /// Optional. A description for the affinity group. The description can
        /// be up to 1024 characters in length.
        /// </summary>
        public string Description
        {
            get { return this._description; }
            set { this._description = value; }
        }
        
        private string _label;
        
        /// <summary>
        /// Required. A base-64-encoded name for the affinity group. The name
        /// can be up to 100 characters in length. Its value defaults to the
        /// Name of the affinity group if not provided.
        /// </summary>
        public string Label
        {
            get
            {
                if (this._label == null)
                {
                    return this.Name;
                }
                else
                {
                    return this._label;
                }
            }
            set { this._label = value; }
        }
        
        private string _location;
        
        /// <summary>
        /// Required. The data center location where the affinity group will be
        /// created. To list available locations, see the List Locations
        /// operation.
        /// </summary>
        public string Location
        {
            get { return this._location; }
            set { this._location = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Required. A name for the affinity group that is unique to the
        /// subscription.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AffinityGroupCreateParameters
        /// class.
        /// </summary>
        public AffinityGroupCreateParameters()
        {
        }
    }
}
