// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure;

namespace Microsoft.WindowsAzure.Management.Models
{
    /// <summary>
    /// The Get Management Certificate operation response.
    /// </summary>
    public partial class ManagementCertificateGetResponse : OperationResponse
    {
        private DateTime _created;
        
        /// <summary>
        /// Optional. The time that the management certificate was created, in
        /// UTC.
        /// </summary>
        public DateTime Created
        {
            get { return this._created; }
            set { this._created = value; }
        }
        
        private byte[] _data;
        
        /// <summary>
        /// Optional. A base-64 representation of the raw data contained in the
        /// management certificate, in cer format.
        /// </summary>
        public byte[] Data
        {
            get { return this._data; }
            set { this._data = value; }
        }
        
        private byte[] _publicKey;
        
        /// <summary>
        /// Optional. A base-64 representation of the management certificate
        /// public key.
        /// </summary>
        public byte[] PublicKey
        {
            get { return this._publicKey; }
            set { this._publicKey = value; }
        }
        
        private string _thumbprint;
        
        /// <summary>
        /// Optional. The thumbprint that uniquely identifies the management
        /// certificate. This thumbprint is the same value as the one
        /// specified by the request URI.
        /// </summary>
        public string Thumbprint
        {
            get { return this._thumbprint; }
            set { this._thumbprint = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ManagementCertificateGetResponse
        /// class.
        /// </summary>
        public ManagementCertificateGetResponse()
        {
        }
    }
}
