// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.WindowsAzure;

namespace Microsoft.WindowsAzure.Management.Network.Models
{
    /// <summary>
    /// A response that indicates the availability of a static IP address, and
    /// if not, provides a list of suggestions.
    /// </summary>
    public partial class NetworkStaticIPAvailabilityResponse : OperationResponse
    {
        private IList<string> _availableAddresses;
        
        /// <summary>
        /// Optional. The list of the available IP addresses.
        /// </summary>
        public IList<string> AvailableAddresses
        {
            get { return this._availableAddresses; }
            set { this._availableAddresses = value; }
        }
        
        private bool _isAvailable;
        
        /// <summary>
        /// Optional. Whether the IP address is available.
        /// </summary>
        public bool IsAvailable
        {
            get { return this._isAvailable; }
            set { this._isAvailable = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// NetworkStaticIPAvailabilityResponse class.
        /// </summary>
        public NetworkStaticIPAvailabilityResponse()
        {
            this._availableAddresses = new List<string>();
        }
    }
}
