// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Resources.Models
{
    /// <summary>
    /// Resource identity.
    /// </summary>
    public partial class ResourceIdentity
    {
        private string _parentResourcePath;
        
        /// <summary>
        /// Optional. Gets or sets parent resource path (optional).
        /// </summary>
        public string ParentResourcePath
        {
            get { return this._parentResourcePath; }
            set { this._parentResourcePath = value; }
        }
        
        private string _resourceName;
        
        /// <summary>
        /// Required. Gets or sets resource name.
        /// </summary>
        public string ResourceName
        {
            get { return this._resourceName; }
            set { this._resourceName = value; }
        }
        
        private string _resourceProviderApiVersion;
        
        /// <summary>
        /// Required. Gets or sets API version of the resource provider.
        /// </summary>
        public string ResourceProviderApiVersion
        {
            get { return this._resourceProviderApiVersion; }
            set { this._resourceProviderApiVersion = value; }
        }
        
        private string _resourceProviderNamespace;
        
        /// <summary>
        /// Required. Gets or sets namespace of the resource provider.
        /// </summary>
        public string ResourceProviderNamespace
        {
            get { return this._resourceProviderNamespace; }
            set { this._resourceProviderNamespace = value; }
        }
        
        private string _resourceType;
        
        /// <summary>
        /// Required. Gets or sets resource type.
        /// </summary>
        public string ResourceType
        {
            get { return this._resourceType; }
            set { this._resourceType = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ResourceIdentity class.
        /// </summary>
        public ResourceIdentity()
        {
        }
    }
}
