// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Net;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.Management.Scheduler.Models;

namespace Microsoft.WindowsAzure.Management.Scheduler.Models
{
    /// <summary>
    /// The Get Job Collection operation response.
    /// </summary>
    public partial class JobCollectionGetResponse : OperationResponse
    {
        private string _eTag;
        
        /// <summary>
        /// Optional. ETag of the Job Collection.
        /// </summary>
        public string ETag
        {
            get { return this._eTag; }
            set { this._eTag = value; }
        }
        
        private JobCollectionIntrinsicSettings _intrinsicSettings;
        
        /// <summary>
        /// Optional. Intrinsic settings for the scheduler job collections.
        /// </summary>
        public JobCollectionIntrinsicSettings IntrinsicSettings
        {
            get { return this._intrinsicSettings; }
            set { this._intrinsicSettings = value; }
        }
        
        private string _label;
        
        /// <summary>
        /// Optional. Label for the resource.
        /// </summary>
        public string Label
        {
            get { return this._label; }
            set { this._label = value; }
        }
        
        private JobCollectionGetResponse.OperationStatus _lastOperationStatus;
        
        /// <summary>
        /// Optional. The promotion code for buying the resource.
        /// </summary>
        public JobCollectionGetResponse.OperationStatus LastOperationStatus
        {
            get { return this._lastOperationStatus; }
            set { this._lastOperationStatus = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Name of the Job Collection.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _promotionCode;
        
        /// <summary>
        /// Optional. The promotion code for buying the resource.
        /// </summary>
        public string PromotionCode
        {
            get { return this._promotionCode; }
            set { this._promotionCode = value; }
        }
        
        private string _schemaVersion;
        
        /// <summary>
        /// Optional. The version of the Intrinsic Properties for your
        /// Resource. If not specified, you must conform to the contract
        /// resource version you registered as default.
        /// </summary>
        public string SchemaVersion
        {
            get { return this._schemaVersion; }
            set { this._schemaVersion = value; }
        }
        
        private JobCollectionState _state;
        
        /// <summary>
        /// Optional. State of the Job Collection.
        /// </summary>
        public JobCollectionState State
        {
            get { return this._state; }
            set { this._state = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the JobCollectionGetResponse class.
        /// </summary>
        public JobCollectionGetResponse()
        {
        }
        
        /// <summary>
        /// Result of a previous operation.
        /// </summary>
        public partial class OperationStatus
        {
            private JobCollectionGetResponse.OperationStatusResponseDetails _responseDetails;
            
            /// <summary>
            /// Optional. Details about the last operation.
            /// </summary>
            public JobCollectionGetResponse.OperationStatusResponseDetails ResponseDetails
            {
                get { return this._responseDetails; }
                set { this._responseDetails = value; }
            }
            
            private SchedulerOperationStatus _status;
            
            /// <summary>
            /// Optional. Status of the last operation.
            /// </summary>
            public SchedulerOperationStatus Status
            {
                get { return this._status; }
                set { this._status = value; }
            }
            
            /// <summary>
            /// Initializes a new instance of the OperationStatus class.
            /// </summary>
            public OperationStatus()
            {
            }
        }
        
        /// <summary>
        /// Response details about an operation.
        /// </summary>
        public partial class OperationStatusResponseDetails
        {
            private string _message;
            
            /// <summary>
            /// Optional. Message returned by the operation.
            /// </summary>
            public string Message
            {
                get { return this._message; }
                set { this._message = value; }
            }
            
            private HttpStatusCode _statusCode;
            
            /// <summary>
            /// Optional. The HTTP status code of the operation.
            /// </summary>
            public HttpStatusCode StatusCode
            {
                get { return this._statusCode; }
                set { this._statusCode = value; }
            }
            
            /// <summary>
            /// Initializes a new instance of the
            /// OperationStatusResponseDetails class.
            /// </summary>
            public OperationStatusResponseDetails()
            {
            }
        }
    }
}
