// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.Scheduler.Models;

namespace Microsoft.WindowsAzure.Scheduler.Models
{
    /// <summary>
    /// The Get Job History operation response.
    /// </summary>
    public partial class JobGetHistoryResponse : OperationResponse, IEnumerable<JobGetHistoryResponse.JobHistoryEntry>
    {
        private IList<JobGetHistoryResponse.JobHistoryEntry> _jobHistory;
        
        /// <summary>
        /// Optional. The job history entries.
        /// </summary>
        public IList<JobGetHistoryResponse.JobHistoryEntry> JobHistory
        {
            get { return this._jobHistory; }
            set { this._jobHistory = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the JobGetHistoryResponse class.
        /// </summary>
        public JobGetHistoryResponse()
        {
            this._jobHistory = new List<JobGetHistoryResponse.JobHistoryEntry>();
        }
        
        /// <summary>
        /// Gets the sequence of JobHistory.
        /// </summary>
        public IEnumerator<JobGetHistoryResponse.JobHistoryEntry> GetEnumerator()
        {
            return this.JobHistory.GetEnumerator();
        }
        
        /// <summary>
        /// Gets the sequence of JobHistory.
        /// </summary>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }
        
        /// <summary>
        /// A job history entry.
        /// </summary>
        public partial class JobHistoryEntry
        {
            private JobHistoryActionName _actionName;
            
            /// <summary>
            /// Optional. The action of this execution, MainAction or
            /// ErrorAction.
            /// </summary>
            public JobHistoryActionName ActionName
            {
                get { return this._actionName; }
                set { this._actionName = value; }
            }
            
            private DateTime _endTime;
            
            /// <summary>
            /// Optional. The time the execution attempt concluded.
            /// </summary>
            public DateTime EndTime
            {
                get { return this._endTime; }
                set { this._endTime = value; }
            }
            
            private string _id;
            
            /// <summary>
            /// Optional. The job id that this history entry is for.
            /// </summary>
            public string Id
            {
                get { return this._id; }
                set { this._id = value; }
            }
            
            private string _message;
            
            /// <summary>
            /// Optional. A description of the result of the execution attempt.
            /// </summary>
            public string Message
            {
                get { return this._message; }
                set { this._message = value; }
            }
            
            private int _repeatCount;
            
            /// <summary>
            /// Optional. The occurrence count of this execution.
            /// </summary>
            public int RepeatCount
            {
                get { return this._repeatCount; }
                set { this._repeatCount = value; }
            }
            
            private int _retryCount;
            
            /// <summary>
            /// Optional. The retry count of this occurrence.
            /// </summary>
            public int RetryCount
            {
                get { return this._retryCount; }
                set { this._retryCount = value; }
            }
            
            private DateTime _startTime;
            
            /// <summary>
            /// Optional. The time the execution attempt began.
            /// </summary>
            public DateTime StartTime
            {
                get { return this._startTime; }
                set { this._startTime = value; }
            }
            
            private JobState _state;
            
            /// <summary>
            /// Optional. The state of the job: enabled, disabled, faulted, or
            /// completed.
            /// </summary>
            public JobState State
            {
                get { return this._state; }
                set { this._state = value; }
            }
            
            private JobHistoryStatus _status;
            
            /// <summary>
            /// Optional. The status of this execution attempt, completed or
            /// failed.
            /// </summary>
            public JobHistoryStatus Status
            {
                get { return this._status; }
                set { this._status = value; }
            }
            
            private DateTime _timestamp;
            
            /// <summary>
            /// Optional. The time the execution attempt began.
            /// </summary>
            public DateTime Timestamp
            {
                get { return this._timestamp; }
                set { this._timestamp = value; }
            }
            
            /// <summary>
            /// Initializes a new instance of the JobHistoryEntry class.
            /// </summary>
            public JobHistoryEntry()
            {
            }
        }
    }
}
