// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;

namespace Microsoft.WindowsAzure.Scheduler.Models
{
    /// <summary>
    /// Request for an http or https action type.
    /// </summary>
    public partial class JobHttpRequest
    {
        private string _body;
        
        /// <summary>
        /// Optional. Request body.
        /// </summary>
        public string Body
        {
            get { return this._body; }
            set { this._body = value; }
        }
        
        private IDictionary<string, string> _headers;
        
        /// <summary>
        /// Optional. Header name value pairs to supply with the http/https
        /// action.
        /// </summary>
        public IDictionary<string, string> Headers
        {
            get { return this._headers; }
            set { this._headers = value; }
        }
        
        private string _method;
        
        /// <summary>
        /// Required. Http method e.g. GET, PUT, POST, DELETE.
        /// </summary>
        public string Method
        {
            get { return this._method; }
            set { this._method = value; }
        }
        
        private Uri _uri;
        
        /// <summary>
        /// Required. Uri of the endpoint to invoke.
        /// </summary>
        public Uri Uri
        {
            get { return this._uri; }
            set { this._uri = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the JobHttpRequest class.
        /// </summary>
        public JobHttpRequest()
        {
            this._headers = new Dictionary<string, string>();
        }
    }
}
