// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.Sql.Models
{
    /// <summary>
    /// SQL Server database copy.
    /// </summary>
    public partial class DatabaseCopy
    {
        private string _destinationDatabaseName;
        
        /// <summary>
        /// Optional. The name of the destination database.
        /// </summary>
        public string DestinationDatabaseName
        {
            get { return this._destinationDatabaseName; }
            set { this._destinationDatabaseName = value; }
        }
        
        private string _destinationServerName;
        
        /// <summary>
        /// Optional. The name of the destination server.
        /// </summary>
        public string DestinationServerName
        {
            get { return this._destinationServerName; }
            set { this._destinationServerName = value; }
        }
        
        private bool _isContinuous;
        
        /// <summary>
        /// Optional. Whether the copy is continous.
        /// </summary>
        public bool IsContinuous
        {
            get { return this._isContinuous; }
            set { this._isContinuous = value; }
        }
        
        private bool _isInterlinkConnected;
        
        /// <summary>
        /// Optional. Whether the database copy is interlink connected.
        /// </summary>
        public bool IsInterlinkConnected
        {
            get { return this._isInterlinkConnected; }
            set { this._isInterlinkConnected = value; }
        }
        
        private bool _isLocalDatabaseReplicationTarget;
        
        /// <summary>
        /// Optional. Whether the local database is the replication target.
        /// </summary>
        public bool IsLocalDatabaseReplicationTarget
        {
            get { return this._isLocalDatabaseReplicationTarget; }
            set { this._isLocalDatabaseReplicationTarget = value; }
        }
        
        private int _localDatabaseId;
        
        /// <summary>
        /// Optional. The ID of the local database.
        /// </summary>
        public int LocalDatabaseId
        {
            get { return this._localDatabaseId; }
            set { this._localDatabaseId = value; }
        }
        
        private string _modifyDate;
        
        /// <summary>
        /// Optional. The UTC date when the database copy became
        /// transactionally consistent.
        /// </summary>
        public string ModifyDate
        {
            get { return this._modifyDate; }
            set { this._modifyDate = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. A unique identifier for the database copy.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _parentLink;
        
        /// <summary>
        /// Optional. A link to the location of the parent resource.
        /// </summary>
        public string ParentLink
        {
            get { return this._parentLink; }
            set { this._parentLink = value; }
        }
        
        private float _percentComplete;
        
        /// <summary>
        /// Optional. Progress towards copy completion.
        /// </summary>
        public float PercentComplete
        {
            get { return this._percentComplete; }
            set { this._percentComplete = value; }
        }
        
        private byte _replicationState;
        
        /// <summary>
        /// Optional. A value indicating the replication state for the database.
        /// </summary>
        public byte ReplicationState
        {
            get { return this._replicationState; }
            set { this._replicationState = value; }
        }
        
        private string _replicationStateDescription;
        
        /// <summary>
        /// Optional. A description of the replication state for the database.
        /// </summary>
        public string ReplicationStateDescription
        {
            get { return this._replicationStateDescription; }
            set { this._replicationStateDescription = value; }
        }
        
        private string _selfLink;
        
        /// <summary>
        /// Optional. A link to the location of the requested resource.
        /// </summary>
        public string SelfLink
        {
            get { return this._selfLink; }
            set { this._selfLink = value; }
        }
        
        private string _sourceDatabaseName;
        
        /// <summary>
        /// Optional. The name of the source database.
        /// </summary>
        public string SourceDatabaseName
        {
            get { return this._sourceDatabaseName; }
            set { this._sourceDatabaseName = value; }
        }
        
        private string _sourceServerName;
        
        /// <summary>
        /// Optional. The name of the source server.
        /// </summary>
        public string SourceServerName
        {
            get { return this._sourceServerName; }
            set { this._sourceServerName = value; }
        }
        
        private string _startDate;
        
        /// <summary>
        /// Optional. The UTC date when the database copy was initiated.
        /// </summary>
        public string StartDate
        {
            get { return this._startDate; }
            set { this._startDate = value; }
        }
        
        private string _state;
        
        /// <summary>
        /// Optional. The state of the database copy.
        /// </summary>
        public string State
        {
            get { return this._state; }
            set { this._state = value; }
        }
        
        private string _type;
        
        /// <summary>
        /// Optional. The type of the object.
        /// </summary>
        public string Type
        {
            get { return this._type; }
            set { this._type = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DatabaseCopy class.
        /// </summary>
        public DatabaseCopy()
        {
        }
    }
}
