// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.WindowsAzure.WebSitesExtensions.Models;

namespace Microsoft.WindowsAzure.WebSitesExtensions
{
    /// <summary>
    /// Operations for managing the repositories.
    /// </summary>
    public partial interface IDeploymentOperations
    {
        /// <summary>
        /// Gets a deployment for a website.
        /// </summary>
        /// <param name='deploymentId'>
        /// The deployment identifier.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// The deployment information operation response.
        /// </returns>
        Task<DeploymentGetResponse> GetAsync(string deploymentId, CancellationToken cancellationToken);
        
        /// <summary>
        /// Gets a deployment log for a website.
        /// </summary>
        /// <param name='deploymentId'>
        /// The deployment identifier.
        /// </param>
        /// <param name='deploymentLogId'>
        /// The deployment log identifier.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// The get log for a deployments operation response.
        /// </returns>
        Task<DeploymentGetLogResponse> GetLogAsync(string deploymentId, string deploymentLogId, CancellationToken cancellationToken);
        
        /// <summary>
        /// List the deployments for a website.
        /// </summary>
        /// <param name='parameters'>
        /// Additional parameters.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// The list of deployments operation response.
        /// </returns>
        Task<DeploymentListResponse> ListAsync(DeploymentListParameters parameters, CancellationToken cancellationToken);
        
        /// <summary>
        /// List the logs for a deployment for a website.
        /// </summary>
        /// <param name='deploymentId'>
        /// The deployment identifier.
        /// </param>
        /// <param name='parameters'>
        /// Additional parameters.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// The list of deployments operation response.
        /// </returns>
        Task<DeploymentListLogsResponse> ListLogsAsync(string deploymentId, DeploymentListParameters parameters, CancellationToken cancellationToken);
        
        /// <summary>
        /// Redeploys a specific website deployment.
        /// </summary>
        /// <param name='deploymentId'>
        /// The deployment identifier.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// The deployment information operation response.
        /// </returns>
        Task<DeploymentUpdateResponse> RedeployAsync(string deploymentId, CancellationToken cancellationToken);
    }
}
