// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.WebSites.Models
{
    /// <summary>
    /// Parameters supplied to the Delete Web Site operation.
    /// </summary>
    public partial class WebSiteDeleteParameters
    {
        private bool _deleteAllSlots;
        
        /// <summary>
        /// Required. Indicates if all slots for the web site should be deleted.
        /// </summary>
        public bool DeleteAllSlots
        {
            get { return this._deleteAllSlots; }
            set { this._deleteAllSlots = value; }
        }
        
        private bool _deleteEmptyServerFarm;
        
        /// <summary>
        /// Required. Indicates if the server farm should be deleted. You can
        /// delete the server farm if the web site being deleted is the last
        /// web site in a server farm.
        /// </summary>
        public bool DeleteEmptyServerFarm
        {
            get { return this._deleteEmptyServerFarm; }
            set { this._deleteEmptyServerFarm = value; }
        }
        
        private bool _deleteMetrics;
        
        /// <summary>
        /// Required. Indicates if the metrics for the web site should be
        /// deleted.
        /// </summary>
        public bool DeleteMetrics
        {
            get { return this._deleteMetrics; }
            set { this._deleteMetrics = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the WebSiteDeleteParameters class.
        /// </summary>
        public WebSiteDeleteParameters()
        {
        }
    }
}
